Loading...
Searching...
No Matches
BALL::LennardJones Class Reference
Molecular Modeling » Molecular Mechanics » Force Field Parameters

`#include <BALL/MOLMEC/PARAMETER/lennardJones.h>`

Inheritance diagram for BALL::LennardJones:

## Classes

struct | Values
struct | Data

## Public Types

Enums
enum | FormatType { A_B_FORMAT , EPSILON_R_FORMAT , SLATER_KIRKWOOD_FORMAT }
Public Types inherited from BALL::ParameterSection
enum | { MAX_FIELDS = 20 }

## Public Member Functions

Constructors and Destructors
| LennardJones ()
| LennardJones (const LennardJones &lj)
virtual | ~LennardJones ()
virtual void | clear ()
virtual bool | extractSection (ForceFieldParameters &parameters, const String &section_name)
virtual bool | extractSection (Parameters &parameters, const String &section_name)
bool | hasParameters (Atom::Type I, Atom::Type J) const
Values | getParameters (Atom::Type I, Atom::Type J) const
bool | assignParameters (Values &parameters, Atom::Type I, Atom::Type J) const
Assignment
const LennardJones & | operator= (const LennardJones &lj)
Public Member Functions inherited from BALL::ParameterSection
| ParameterSection ()
| ParameterSection (const ParameterSection &parameter_section)
virtual | ~ParameterSection ()
bool | extractSection (Parameters &parameters, const String &section_name)
const String & | getSectionName () const
const String & | getValue (const String &key, const String &variable) const
bool | has (const String &key, const String &variable) const
bool | has (const String &key) const
bool | hasVariable (const String &variable) const
Position | getColumnIndex (const String &variable) const
Size | getNumberOfVariables () const
Size | getNumberOfKeys () const
const String & | getValue (Position key_index, Position variable_index) const
const String & | getKey (Position key_index) const
const ParameterSection & | operator= (const ParameterSection &section)
virtual bool | isValid () const
bool | operator== (const ParameterSection &parameter_section) const

## Predicates

Size | number_of_atom_types_
std::vector< float > | A_
std::vector< float > | B_
std::vector< float > | N_
std::vector< float > | Aij_
std::vector< float > | Bij_
std::vector< bool > | is_defined_
FormatType | format_
std::vector< String > | names_
bool | operator== (const LennardJones &lj) const

## Additional Inherited Members

Options | options
Static Public Attributes inherited from BALL::ParameterSection
static const String | UNDEFINED
String | section_name_
String | format_line_
StringHashMap< Index > | section_entries_
StringHashMap< Index > | variable_names_
std::vector< String > | entries_
std::vector< String > | keys_
Size | number_of_variables_
std::vector< float > | version_
bool | valid_

## Detailed Description

Lennard Jones parameter section. This section reads parameters for a Lennard Jones potental (usually a 6-12 Potential). Parameters may be given in three different formats (no mixing of formats is allowed).

- A and B are given directly ( A_B_FORMAT )
- well depth and minimum radii ( EPSILON_R_FORMAT )
- Slater-Kirkwood parameters ( SLATER_KIRKWOOD_FORMAT )

If the Slater-Kirkwood format is used, the values for and are calculated as follows (see e.g. Brooks et al., J. Comput. Chem, 4(2):187-217 (1983))

Definition at line 42 of file lennardJones.h.

## Member Enumeration Documentation

## FormatType

enum BALL::LennardJones::FormatType

Enumerator
A_B_FORMAT |
EPSILON_R_FORMAT |
SLATER_KIRKWOOD_FORMAT |

Definition at line 51 of file lennardJones.h.

## Constructor & Destructor Documentation

## LennardJones() [1/2]

BALL::LennardJones::LennardJones | ( |  | ) |

Default constructor.

## LennardJones() [2/2]

BALL::LennardJones::LennardJones | ( | const LennardJones & | lj | ) |

Copy constructor.

## ~LennardJones()

virtual BALL::LennardJones::~LennardJones | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## assignParameters()

bool BALL::LennardJones::assignParameters | ( | Values & | parameters,
|  | Atom::Type | I,
|  | Atom::Type | J ) const

Assign the parameters for a given atom type combination. If no parameters are defined for this combination, false is returned and nothing is changed.

## clear()

virtual void BALL::LennardJones::clear | ( |  | ) |

virtual

Clear method.

Reimplemented from BALL::ParameterSection.

## extractSection() [1/2]

virtual bool BALL::LennardJones::extractSection | ( | ForceFieldParameters & | parameters,
|  | const String & | section_name )

virtual

Reads a parameter section from an INI file. This method reads the section given in section_name from ini_file, interprets (if given) a format line, reads the data from this section according to the format, and builds some datastructures for fast and easy access to this data.

## extractSection() [2/2]

virtual bool BALL::LennardJones::extractSection | ( | Parameters & | parameters,
|  | const String & | section_name )

virtual

## getParameters()

Values BALL::LennardJones::getParameters | ( | Atom::Type | I,
|  | Atom::Type | J ) const

Returns the parameters for a given atom type combination.

## hasParameters()

bool BALL::LennardJones::hasParameters | ( | Atom::Type | I,
|  | Atom::Type | J ) const

Queries whether a parameter set is defined for the given atom types.

## operator=()

const LennardJones & BALL::LennardJones::operator= | ( | const LennardJones & | lj | ) |

Assignment operator

## operator==()

bool BALL::LennardJones::operator== | ( | const LennardJones & | lj | ) | const

Equality operator

## Member Data Documentation

## A_

std::vector<float> BALL::LennardJones::A_

protected

Definition at line 154 of file lennardJones.h.

## Aij_

std::vector<float> BALL::LennardJones::Aij_

protected

Definition at line 160 of file lennardJones.h.

## B_

std::vector<float> BALL::LennardJones::B_

protected

Definition at line 156 of file lennardJones.h.

## Bij_

std::vector<float> BALL::LennardJones::Bij_

protected

Definition at line 162 of file lennardJones.h.

## format_

FormatType BALL::LennardJones::format_

protected

Definition at line 166 of file lennardJones.h.

## is_defined_

std::vector<bool> BALL::LennardJones::is_defined_

protected

Definition at line 164 of file lennardJones.h.

## N_

std::vector<float> BALL::LennardJones::N_

protected

Definition at line 158 of file lennardJones.h.

## names_

std::vector<String> BALL::LennardJones::names_

protected

Definition at line 168 of file lennardJones.h.

## number_of_atom_types_

Size BALL::LennardJones::number_of_atom_types_

protected

Definition at line 152 of file lennardJones.h.